﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.1
@EndOfDesignText@
' *#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*
' 
' B4X Sessions library started by ThRuST August 2, 2021.
' Please continue my work and add your name, date and notes to the history log.
' Original forum Post: https://www.b4x.com/android/forum/threads/poststring-with-php-session-variables.133084
' Remove the GUI and compile it to a library of just add the module B4XSessions to your project to use it.

' HISTORY LOG (Don't forget to update library version below and in Main #Region Project Attributes for B4X IDE)

' Current version: v0.3
' -----------
' User				Date				Notes

' ThRuST			2021-08-02			Started coding on B4X Sessions :-)
' ThRuST			2021-08-02			v0.2 Update. Library now creates server cookies in the domain /Cookies subfolder.
' ThRuST			2021-08-02			v0.3 Default Poststring method implemented with a passed string for easier handling.
'										Credits to Oliver for his contribution.

' ThRuST			2021-08-03			v0.4 It's now possible to create and remove a cookie on the server.
'										check.php checks if a file exists on the server. However not by using POST
'										so the data musc be handled from the server because POST data are lost whenever
'										'fx.ShowExternalDocument is opened (which is the main problem in the first place).
'
'
' 
' 
' 
'
' Welcome to contribute to this library. Improve it, embrace it, leave your mark upon it.
' *#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*

' These PHP scripts are needed - Prefferably create.php for this example (Change in Public SETpath below)
' Store it on your domain and set the domain info before running code.

' *#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*
' 
' Please note: The php script below are related to B4X Sessions alternative functionality.
' You need to have these files on your server to create session cookies. Then change the DomainPath variable.

'(create.php)

'<?php
'
'	// Recieve POST string To create Cookies subfolder
'	$CookieFolder 	= $_POST['CookieFolder'];
'	$CreateUID 		= $_POST['CreateUID'];
'
'	// Create Cookies folder
'	mkdir($CookieFolder);
'
'	// Change directory To Cookies folder
'	chdir($CookieFolder);
'
'	// Create Cookie File
'	$CookieCreate = fopen($CreateUID, "w")
'
'?>

' (remove.php)

'<?php
'
'	// Recieve POST string To create Cookies subfolder
'	$CookieFolder 	= $_POST['CookieFolder'];
'	$RemoveUID 	= $_POST['RemoveUID'];
'
'	// Remove files in Cookie folder
'	$dir = $CookieFolder . "/";
'	array_map('unlink', glob("{$dir}" . $RemoveUID));
'
'?>

'(check.php)

'<?php
'
'	$CookieFolder 	= "Cookies";
'	$CheckUID 		= "1627580073964893881104629331612202613825855710527480866101217920394995325";
'
'	If (is_file($CookieFolder . "/" . $CheckUID))
'	{
'		echo "File exists";
'	} Else
'
'	{
'		echo "File not found";
'	}
'
'?>

'Static code module
Sub Process_Globals
	
	Private fx As JFX
	Private xui As XUI
	Private Tal1, Tal2, Tal3, Tal4, Tal5, Tal6, Tal7, Tal8 As Int
	
	Public UID As String
	
	' >>> Make sure you change these before running the code for the Cookies folder and UID file will be created on your domain <<<
	Public DomainPath 	As String = "https://www.domain.com" 		' NOTE: Forwardslash "/" not needed here
	Public SETPath 		As String = DomainPath & "/" & "create.php"	' PHP filename that creates the cookie file
	Public UNSETPath 	As String = DomainPath & "/" & "remove.php"	' PHP filename that removes the cookie file
	Public CHECKPath 	As String = DomainPath & "/" & "check.php"	' PHP filename that checks if the cookie file exists
	Public CookieFolder As String = "Cookies"						' The subfolder name to store session cookies
	
End Sub

' Generates a unique User Identification number.
' Usage: B4XSessions.GenerateUID(DestinationString)
' Access current UID from Public string variable B4XSessions.UID
Public Sub GenerateUID (x As String)
	
	Tal1  = Rnd(10000, 99999999999)
	Tal2  = Rnd(10000, 99999999999)
	Tal3  = Rnd(10000, 99999999999)
	Tal4  = Rnd(10000, 99999999999)
	Tal5  = Rnd(10000, 99999999999)
	Tal6  = Rnd(10000, 99999999999)
	Tal7  = Rnd(10000, 99999999999)
	Tal8  = Rnd(10000, 99999999999)
 
	UID = Tal1 & Tal2 & Tal3 & Tal4 & Tal5 & Tal6 & Tal7 & Tal8
 
 	' You might want to disable Log block below as it's for debug usage only.
 	Log("-------------------")
	Log("New generated UID:")
	Log(UID)
 
	Return UID
 
End Sub

' Returns the Domain path to B4X session cookies.
' Usage B4XSessions.DomainPath(DestinationString)
Public Sub Domain (x As String)
	
	Return DomainPath
	
End Sub

' This is the default Poststring to handle POST request the standard way.
' You should modify it to your needs. Default dependency PHP scrips are get.php and set.php
' Usage: B4XSessions.SendPostRequest(DestinationString)
Public Sub SendPostRequest (xstr As String)
	
	Dim sendjob1 As HttpJob
	Dim response As String

	' Init okHttpUtils2
	sendjob1.Initialize("", Me)

	'Send a POST request
	sendjob1.PostString(DomainPath & "/" & "set.php", "var1=" & xstr)

	Wait For (sendjob1) JobDone(sendjob1 As HttpJob)

	If sendjob1.Success Then
		'the modified PHP script should return the session id
		response = sendjob1.GetString
		
		' Open webbrowser to see the session results
		fx.ShowExternalDocument(DomainPath & $"/get.php?session=${response}"$)
	Else
		response = sendjob1.ErrorMessage
	End If

	sendjob1.Release
	
End Sub

' Creates a session cookie on the server by calling online PHP script.
' Usage: B4XSessions.SETSession
Public Sub SETSession
	
	' Creates the UID file on the server PHP call script from here.
	
	Dim sendjob1 As HttpJob
	Dim response As String
    
	' Init okHttpUtils2
	sendjob1.Initialize("", Me)
    
	' Sends multiple POST requests
	sendjob1.PostString(SETPath, _
    "CookieFolder=" & CookieFolder & _
    "&CreateUID=" & UID)
	
	Wait For (sendjob1) JobDone(sendjob1 As HttpJob)

	If sendjob1.Success Then
		xui.MsgboxAsync("Data was sent to server.", "")
 
		response = sendjob1.GetString
		Log("Log Start -----------------------------------------------------------")
		Log(response & " " & CRLF)
		Log("Log End -------------------------------------------------------------")
		
		'fx.ShowExternalDocument("https://www.")
		
	Else
		response = sendjob1.ErrorMessage
		xui.MsgboxAsync("Data could not be sent. Check Domain info in B4XSessions module.", "")
	End If
	'WebView1.LoadHtml(response)

	sendjob1.Release
	
End Sub

' Removes a session cookie on the server by calling online PHP script.
' Usage: B4XSessions.UNSETSession
Public Sub UNSETSession
	
	' Removes the UID file on the server PHP call script from here.
	
	Dim sendjob1 As HttpJob
	Dim response As String
    
	' Init okHttpUtils2
	sendjob1.Initialize("", Me)
    
	' Sends multiple POST requests
	sendjob1.PostString(UNSETPath, _
    "CookieFolder=" & CookieFolder & _
    "&RemoveUID=" & UID)
	
	Wait For (sendjob1) JobDone(sendjob1 As HttpJob)

	If sendjob1.Success Then
		xui.MsgboxAsync("Domain successfully contacted.", "")
 
		response = sendjob1.GetString
		Log("Log Start -----------------------------------------------------------")
		Log(response & " " & CRLF)
		Log("Log End -------------------------------------------------------------")
		
		'fx.ShowExternalDocument("https://www.")
		
	Else
		response = sendjob1.ErrorMessage
		xui.MsgboxAsync("Data could not be sent. Check Domain info in B4XSessions module.", "")
	End If
	'WebView1.LoadHtml(response)

	sendjob1.Release
	
End Sub

' Checks if a session cookie exists on the server by calling online PHP script.
' Usage: B4XSessions.CHECKSession
Public Sub CHECKSession
	
	' Removes the UID file on the server PHP call script from here.
	
	Dim sendjob1 As HttpJob
	Dim response As String
    
	' Init okHttpUtils2
	sendjob1.Initialize("", Me)
    
	' Sends multiple POST requests
	sendjob1.PostString(CHECKPath, _
    "CookieFolder=" & CookieFolder & _
    "&CheckUID=" & UID)
	
	Wait For (sendjob1) JobDone(sendjob1 As HttpJob)

	If sendjob1.Success Then
		'xui.MsgboxAsync("Domain successfully contacted.", "")
 
		response = sendjob1.GetString
		Log("Log Start -----------------------------------------------------------")
		Log(response & " " & CRLF)
		Log("Log End -------------------------------------------------------------")
		
		'fx.ShowExternalDocument("https://www.")
		fx.ShowExternalDocument(CHECKPath)
		
	Else
		response = sendjob1.ErrorMessage
		xui.MsgboxAsync("Data could not be sent. Check Domain info in B4XSessions module.", "")
	End If
	'WebView1.LoadHtml(response)

	sendjob1.Release
	
End Sub
